timestamp = None
send_cmd=True
from   machine import Pin,Timer
import time
tmrsuppress=Timer(-1)

from   rp2     import asm_pio, PIO, StateMachine

Helm_Bytes=[[0x01,0xFE],[0x02,0xFD],[0x06,0xF9],[0x08,0xF7]] #2 bytes for auto, 2 for standby.

TX_PIN = 0
RX_PIN = 1
BAUD   = 4800

@asm_pio(sideset_init = PIO.OUT_HIGH,
         out_init     = PIO.OUT_HIGH,
         out_shiftdir = PIO.SHIFT_RIGHT,
         fifo_join    = PIO.JOIN_TX)
def PioTx9N1(BITS=9):
    pull()            .side(1)  [7]
    set(x, BITS-1)    .side(0)  [7]
    label("txloop")
    out(pins, 1)
    jmp(x_dec, "txloop")        [6]

@asm_pio(set_init     = PIO.IN_HIGH,
         in_shiftdir  = PIO.SHIFT_RIGHT,
         fifo_join    = PIO.JOIN_RX)
def PioRx9N1(BITS=9):
    wait( 0, pin, 0)
    set(x, BITS-1)              [10]
    label("rxloop")
    in_(pins, 1)
    jmp(x_dec, "rxloop")        [6]
    push()

# Need to initialise RX first if using same pin for TX

rxPin = Pin(RX_PIN, Pin.IN, Pin.PULL_UP)
rx = StateMachine(0, PioRx9N1, freq=BAUD * 8, in_base=rxPin)
rx.active(1)

txPin = Pin(TX_PIN, Pin.OUT, value=1)
tx = StateMachine(1, PioTx9N1, freq=BAUD * 8, sideset_base=txPin, out_base=txPin)
tx.active(1)

def Tx(n):
    print("TX  >  {:>03X}  {:>09b}".format(n, n))
    tx.put(n)

def Rx():
    n = rx.get() >> 23
    print("RX  <  {:>03X}  {:>09b}".format(n, n))
    return n

def AnyAvailable():
    return rx.rx_fifo()

# Flush any data caused by confguration glitches

time.sleep(0.1)
if AnyAvailable():
    print("Flushing\n")
    while AnyAvailable():
        discard = Rx()
        if not AnyAvailable():
            time.sleep(0.1)
    print("")
def suppress_repeat(nothing):
    global send_cmd
    print("###")
    send_cmd=True
    #LastSend=0
    
    
def Send_Ahelm(cmd):
    try:
        global Helm_Bytes,send_cmd
      
        print(cmd)
        Tx(0x186) #command byte  AH attribute
        Tx(0x11)  #AutoHelm attribute 
        for i in range(2):
            Tx(Helm_Bytes[cmd-1][i])
          #  time.sleep(0.001)
        send_cmd=False
        
    except:
        print("error")
   
while True: # just send auto/standby every second as a proof of concept.
    Send_Ahelm(1)
    time.sleep(2)
    Send_Ahelm(2)
    time.sleep(2)
 